/*
   All parameters in C are call-by-value, so
   the value of a caller's actual parameter is
   COPIED into the callee's formal parameter.

   Call-by-value of an int (a "primitive" value).
*/
#include <stdio.h>


void f(int x) // call-by-value
{
   printf("in f, x = %d\n", x);
   x = 0;   // This has no effect on the caller's actual parameter.
}


int main(void)
{
   int x = 5;
   f(x);
   printf("in main, x = %d\n", x);

   return 0;
}
