/*
   All parameters in C are call-by-value, so
   the value of a caller's actual parameter is
   COPIED into the callee's formal parameter.

   Call-by-value of a struct that holds only an array.
*/
#include <stdio.h>


struct MyType {
   int a[10];   // Try declaring a larger array.
};

void f(struct MyType x) // call-by-value
{
   printf("in f, x.a[4] = %d\n", x.a[4]);
   x.a[4] = 0;   // This has no effect on the caller's actual parameter.
}


int main(void)
{
   struct MyType x = {{1,2,3,4,5,6,7,8,9,10}}; // Array inside of a struct.
   f(x);
   printf("in main, x.a[4] = %d\n", x.a[4]);

   return 0;
}
