/*
   All parameters in C are call-by-value, so
   the value of a caller's actual parameter is
   COPIED into the callee's formal parameter.

   Call-by-value of a struct (an "object" like value).
*/
#include <stdio.h>


struct MyType {
   int w;
   int x;
   int y;
   int z;
};

void f(struct MyType x) // call-by-value
{
   printf("in f, x.x = %d\n", x.x);
   x.x = 0;   // This has no effect on the caller's actual parameter.
}


int main(void)
{
   struct MyType x = {1, 2, 3, 4};
   f(x);
   printf("in main, x.x = %d\n", x.x);

   return 0;
}
