/*
   All parameters in C are call-by-value, so
   the value of a caller's actual parameter is
   COPIED into the callee's formal parameter.

   Call-by-value of an array (which ends up as "call-by-pointer").
*/
#include <stdio.h>

/*  http://c-faq.com/aryptr/aryptrparam.html  */
void f(int x[4]) // call-by-value (of a pointer)
{
   printf("in f, x[1] = %d\n", x[1]);
   x[1] = 0;   // This changes the caller's actual parameter.
}


int main(void)
{
   int x[4] = {1, 2, 3, 4};
   f(x);
   printf("in main, x[1] = %d\n", x[1]);

   return 0;
}
