/*
   All parameters in C are call-by-value, so
   the value of a caller's actual parameter is
   COPIED into the callee's formal parameter.

   Call-by-value of a string (which ends up as "call-by-pointer").
*/
#include <stdio.h>

/*  http://c-faq.com/aryptr/aryptrparam.html  */
void f(char x[4]) // call-by-value (of a pointer)
{
   printf("in f, x[1] = %c\n", x[1]);
   x[1] = 'z'; // This changes the caller's actual parameter.
}


int main(void)
{
   char x[4] = "cat";
   f(x);
   printf("in main, x[1] = %c\n", x[1]);

   return 0;
}
