/*
   All parameters in C are call-by-value, so
   the value of a caller's actual parameter is
   COPIED into the callee's formal parameter.

   Call-by-value of a pointer value.
   Pointee is allocated on the stack.
*/
#include <stdio.h>


void f(int *x) // call-by-value (of a pointer)
{
   printf("in f, *x = %d\n", *x);
   *x = 0;  // This doesn't change the caller's value of the pointer,
}           // but it does change the caller's value of the pointee.


int main(void)
{
   int x = 5;  // Create the pointee (on the stack).
   f(&x);      // Create the pointer (pointing at the pointee).
   printf("in main, x = %d\n", x);

   return 0;
}
