/*
   All parameters in C are call-by-value, so
   the value of a caller's actual parameter is
   COPIED into the callee's formal parameter.

   Call-by-value of a pointer value.
   Pointee is allocated on the stack.
*/
#include <stdio.h>


struct MyType {
   int w;
   int x;
   int y;
   int z;
};

void f(struct MyType *x) // call-by-value (of a pointer)
{
   printf("in f, x->x = %d\n", (*x).x);
   x->x = 0;  // This doesn't change the caller's value of the pointer,
}             // but it does change the caller's value of the pointee.


int main(void)
{
   struct MyType x = {1, 2, 3, 4};  // Create the pointee (on the stack).
   f(&x);                           // Create the pointer (pointing at the pointee).
   printf("in main, x.x = %d\n", x.x);

   return 0;
}
