/*
   All parameters in C are call-by-value, so
   the value of a caller's actual parameter is
   COPIED into the callee's formal parameter.

   Call-by-value of a pointer value.
   Pointee is allocated in the heap.
*/
#include <stdio.h>
#include <stdlib.h>

void f(int *x) // call-by-value (of a pointer)
{
   printf("in f, *x = %d\n", *x);
   // What do the following three lines do?
   free(x);
   x = (int*)malloc(sizeof(int));
   *x = 0;
}


int main(void)
{
   int *x;                         // Create the pointer (on the stack).
   x = (int*)malloc(sizeof(int));  // Create the pointee (in the heap).
   *x = 5;                         // Give the pointee a value.
   f(x);
   printf("in main, *x = %d\n", *x); // WHAT IS WRONG NOW?
   free(x); // De-allocate the pointee from the heap.

   return 0;
}
